/** @file 
* \brief Header de excepción de Sockets
* \author Imanol Barba Sabariego
* \date 10/06/2013
* 
* En este fichero se define la clase SocketException para el control de excepciones producidas por la librería.
*/

#ifndef SOCKETEXCEPTION_H_
#define SOCKETEXCEPTION_H_

#include <string>

using namespace std;

//! Clase de Excepción de Sockets
/**
Definición de las excepciones lanzadas por la librería de comunicación TCP/IP 
*/
class SocketException
{
	public:
		//! Constructor de la clase
		/*! Inicializa el mensaje */
		SocketException ( string m /**< Mensaje inicial */ ) : message ( m ) {};
		~SocketException (){};
		//! Getter del atributo message
		/*! Devuelve el mensaje asociado a la excepción producida */
		string description() { return message; }
	private:
		//! Mensaje asociado a la excepción producida
		string message; 
};
#endif /* SOCKETEXCEPTION_H_ */